package io.dekorate.adapter;

import java.util.stream.Collectors;
import io.dekorate.annotation.Dekorate;
import java.lang.Object;
import java.util.List;
import java.lang.String;
import java.util.Arrays;
import io.dekorate.config.DekorateConfigBuilder;
import java.util.Map;
import io.dekorate.config.DekorateConfig;

public class DekorateConfigAdapter {


    public static DekorateConfig adapt(Dekorate instance) {
        return newBuilder(instance).build();
    }

    public static DekorateConfigBuilder newBuilder(Dekorate instance) {
        return new DekorateConfigBuilder(new io.dekorate.config.DekorateConfig(instance.resources()));
    }

    public static DekorateConfig adapt(Map map) {
        return new io.dekorate.config.DekorateConfig(
        map instanceof Map ? toStringArray(((Map)map).get("resources")) : toStringArray(map));
    }

    public static DekorateConfigBuilder newBuilder(Map map) {
        return new DekorateConfigBuilder(new io.dekorate.config.DekorateConfig(
        map instanceof Map ? toStringArray(((Map)map).get("resources")) : toStringArray(map)));
    }

    public static String[] toStringArray(Object o) {
                if (o instanceof String[]) {
                  return (String[]) o;
                }
                if (o instanceof String) {
                  String s =  (String) o;
                  return s.split(",[ ]*");
                }
                else if (o instanceof List) {
                  List c = (List) o;
                  String[] result = new String[c.size()]; 
                  for (int i=0; i <= c.size(); i++) {
                    result[i] = String.valueOf(c.get(i));
                  }
                  return result;
                }
                return new String[0];
            
    }

}
