package io.dekorate.kubernetes.adapter;

import java.util.stream.Collectors;
import io.dekorate.kubernetes.config.PersistentVolumeClaimConfigBuilder;
import io.dekorate.kubernetes.config.Label;
import java.lang.String;
import io.dekorate.project.Project;
import io.dekorate.project.BuildInfo;
import io.dekorate.kubernetes.config.PersistentVolumeClaimConfig;
import io.dekorate.kubernetes.annotation.PersistentVolumeClaim;
import java.lang.Object;
import java.util.List;
import io.dekorate.kubernetes.annotation.AccessMode;
import io.dekorate.project.ScmInfo;
import java.util.Arrays;
import java.util.Map;

public class PersistentVolumeClaimConfigAdapter {


    public static PersistentVolumeClaimConfig adapt(PersistentVolumeClaim instance) {
        return newBuilder(instance).build();
    }

    public static PersistentVolumeClaimConfigBuilder newBuilder(PersistentVolumeClaim instance) {
        return new PersistentVolumeClaimConfigBuilder(new io.dekorate.kubernetes.config.PersistentVolumeClaimConfig(null,
                    null,
                    null,
                    instance.name(),
                    null,
                    instance.size(),
                    instance.unit(),
                    instance.storageClass(),
                    instance.accessMode(),
                    Arrays.asList(instance.matchLabels()).stream().map(i ->new io.dekorate.kubernetes.config.Label(i.key(),
                    i.value(),
                    i.kinds())).collect(Collectors.toList()).toArray(new io.dekorate.kubernetes.config.Label[0])));
    }

    public static PersistentVolumeClaimConfig adapt(Map map) {
        return new io.dekorate.kubernetes.config.PersistentVolumeClaimConfig(
        null,
        null,
        null,
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("name", null) : null),
        null,
                       Integer.parseInt(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("size","0") : "0")),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("unit", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("storageClass", null) : null),
                       (AccessMode)(map instanceof Map ? ( ((Map)map).getOrDefault("accessMode", null) != null ? AccessMode.valueOf(String.valueOf(((Map)map).getOrDefault("accessMode", null))) : null ) : null),
                       Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("matchLabels" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Label(
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("key", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("value", null) : null),
        i instanceof Map ? toStringArray(((Map)i).get("kinds")) : toStringArray(i))).toArray(size-> new io.dekorate.kubernetes.config.Label[size]));
    }

    public static PersistentVolumeClaimConfigBuilder newBuilder(Map map) {
        return new PersistentVolumeClaimConfigBuilder(new io.dekorate.kubernetes.config.PersistentVolumeClaimConfig(
        null,
        null,
        null,
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("name", null) : null),
        null,
                       Integer.parseInt(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("size","0") : "0")),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("unit", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("storageClass", null) : null),
                       (AccessMode)(map instanceof Map ? ( ((Map)map).getOrDefault("accessMode", null) != null ? AccessMode.valueOf(String.valueOf(((Map)map).getOrDefault("accessMode", null))) : null ) : null),
                       Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("matchLabels" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Label(
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("key", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("value", null) : null),
        i instanceof Map ? toStringArray(((Map)i).get("kinds")) : toStringArray(i))).toArray(size-> new io.dekorate.kubernetes.config.Label[size])));
    }

    public static String[] toStringArray(Object o) {
                if (o instanceof String[]) {
                  return (String[]) o;
                }
                if (o instanceof String) {
                  String s =  (String) o;
                  return s.split(",[ ]*");
                }
                else if (o instanceof List) {
                  List c = (List) o;
                  String[] result = new String[c.size()]; 
                  for (int i=0; i <= c.size(); i++) {
                    result[i] = String.valueOf(c.get(i));
                  }
                  return result;
                }
                return new String[0];
            
    }

}
