package io.dekorate.kubernetes.config;

import java.lang.Object;
import java.lang.String;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class Annotation {

    private String key;
    private String value;
    private String[] kinds = new java.lang.String[0];

    public Annotation() {
    }

    public Annotation(String key,String value,String[] kinds) {
        this.key = key;
        this.value = value;
        this.kinds = kinds != null ? kinds : new java.lang.String[0];
    }

    public String getKey() {
        return this.key;
    }

    public String getValue() {
        return this.value;
    }

    public String[] getKinds() {
        return this.kinds;
    }

    public static AnnotationBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.AnnotationBuilder();
    }

    public static AnnotationBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.AnnotationBuilder();
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Annotation that = (Annotation) o;
        if (key != null ? !key.equals(that.key) :that.key != null) return false;
        if (value != null ? !value.equals(that.value) :that.value != null) return false;
        if (kinds != null ? !kinds.equals(that.kinds) :that.kinds != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(key,  value,  kinds,  super.hashCode());
    }

}
