package io.dekorate.kubernetes.config;

import java.lang.Integer;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class AwsElasticBlockStoreVolume {

    private String volumeName;
    private String volumeId;
    private Integer partition;
    private String fsType;
    private Boolean readOnly;

    public AwsElasticBlockStoreVolume() {
    }

    public AwsElasticBlockStoreVolume(String volumeName,String volumeId,Integer partition,String fsType,Boolean readOnly) {
        this.volumeName = volumeName;
        this.volumeId = volumeId;
        this.partition = partition;
        this.fsType = fsType;
        this.readOnly = readOnly;
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public String getVolumeId() {
        return this.volumeId;
    }

    public Integer getPartition() {
        return this.partition;
    }

    public String getFsType() {
        return this.fsType;
    }

    public Boolean getReadOnly() {
        return this.readOnly;
    }

    public boolean isReadOnly() {
        return this.readOnly != null &&  this.readOnly;
    }

    public static AwsElasticBlockStoreVolumeBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder();
    }

    public static AwsElasticBlockStoreVolumeBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder().withFsType("ext4").withReadOnly(false);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AwsElasticBlockStoreVolume that = (AwsElasticBlockStoreVolume) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (volumeId != null ? !volumeId.equals(that.volumeId) :that.volumeId != null) return false;
        if (partition != null ? !partition.equals(that.partition) :that.partition != null) return false;
        if (fsType != null ? !fsType.equals(that.fsType) :that.fsType != null) return false;
        if (readOnly != null ? !readOnly.equals(that.readOnly) :that.readOnly != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  volumeId,  partition,  fsType,  readOnly,  super.hashCode());
    }

}
