package io.dekorate.kubernetes.config;

import java.lang.Integer;
import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class AwsElasticBlockStoreVolumeFluentImpl<A extends AwsElasticBlockStoreVolumeFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements AwsElasticBlockStoreVolumeFluent<A> {

    private String volumeName;
    private String volumeId;
    private Integer partition;
    private String fsType;
    private Boolean readOnly;

    public AwsElasticBlockStoreVolumeFluentImpl() {
    }

    public AwsElasticBlockStoreVolumeFluentImpl(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume instance) {
        this.withVolumeName(instance.getVolumeName()); 
        this.withVolumeId(instance.getVolumeId()); 
        this.withPartition(instance.getPartition()); 
        this.withFsType(instance.getFsType()); 
        this.withReadOnly(instance.getReadOnly()); 
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public A withVolumeName(String volumeName) {
        this.volumeName=volumeName; return (A) this;
    }

    public Boolean hasVolumeName() {
        return this.volumeName != null;
    }

    public A withNewVolumeName(String arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuilder arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuffer arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public String getVolumeId() {
        return this.volumeId;
    }

    public A withVolumeId(String volumeId) {
        this.volumeId=volumeId; return (A) this;
    }

    public Boolean hasVolumeId() {
        return this.volumeId != null;
    }

    public A withNewVolumeId(String arg1) {
        return (A)withVolumeId(new String(arg1));
    }

    public A withNewVolumeId(StringBuilder arg1) {
        return (A)withVolumeId(new String(arg1));
    }

    public A withNewVolumeId(StringBuffer arg1) {
        return (A)withVolumeId(new String(arg1));
    }

    public Integer getPartition() {
        return this.partition;
    }

    public A withPartition(Integer partition) {
        this.partition=partition; return (A) this;
    }

    public Boolean hasPartition() {
        return this.partition != null;
    }

    public String getFsType() {
        return this.fsType;
    }

    public A withFsType(String fsType) {
        this.fsType=fsType; return (A) this;
    }

    public Boolean hasFsType() {
        return this.fsType != null;
    }

    public A withNewFsType(String arg1) {
        return (A)withFsType(new String(arg1));
    }

    public A withNewFsType(StringBuilder arg1) {
        return (A)withFsType(new String(arg1));
    }

    public A withNewFsType(StringBuffer arg1) {
        return (A)withFsType(new String(arg1));
    }

    public Boolean getReadOnly() {
        return this.readOnly;
    }

    public A withReadOnly(Boolean readOnly) {
        this.readOnly=readOnly; return (A) this;
    }

    public Boolean hasReadOnly() {
        return this.readOnly != null;
    }

    public A withNewReadOnly(String arg1) {
        return (A)withReadOnly(new Boolean(arg1));
    }

    public A withNewReadOnly(boolean arg1) {
        return (A)withReadOnly(new Boolean(arg1));
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AwsElasticBlockStoreVolumeFluentImpl that = (AwsElasticBlockStoreVolumeFluentImpl) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (volumeId != null ? !volumeId.equals(that.volumeId) :that.volumeId != null) return false;
        if (partition != null ? !partition.equals(that.partition) :that.partition != null) return false;
        if (fsType != null ? !fsType.equals(that.fsType) :that.fsType != null) return false;
        if (readOnly != null ? !readOnly.equals(that.readOnly) :that.readOnly != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  volumeId,  partition,  fsType,  readOnly,  super.hashCode());
    }

}
