package io.dekorate.kubernetes.config;

import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class AzureDiskVolume {

    private String volumeName;
    private String diskName;
    private String diskURI;
    private String kind;
    private String cachingMode;
    private String fsType;
    private Boolean readOnly;

    public AzureDiskVolume() {
    }

    public AzureDiskVolume(String volumeName,String diskName,String diskURI,String kind,String cachingMode,String fsType,Boolean readOnly) {
        this.volumeName = volumeName;
        this.diskName = diskName;
        this.diskURI = diskURI;
        this.kind = kind;
        this.cachingMode = cachingMode;
        this.fsType = fsType;
        this.readOnly = readOnly;
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public String getDiskName() {
        return this.diskName;
    }

    public String getDiskURI() {
        return this.diskURI;
    }

    public String getKind() {
        return this.kind;
    }

    public String getCachingMode() {
        return this.cachingMode;
    }

    public String getFsType() {
        return this.fsType;
    }

    public Boolean getReadOnly() {
        return this.readOnly;
    }

    public boolean isReadOnly() {
        return this.readOnly != null &&  this.readOnly;
    }

    public static AzureDiskVolumeBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.AzureDiskVolumeBuilder();
    }

    public static AzureDiskVolumeBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.AzureDiskVolumeBuilder().withKind("Managed").withCachingMode("ReadWrite").withFsType("ext4").withReadOnly(false);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AzureDiskVolume that = (AzureDiskVolume) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (diskName != null ? !diskName.equals(that.diskName) :that.diskName != null) return false;
        if (diskURI != null ? !diskURI.equals(that.diskURI) :that.diskURI != null) return false;
        if (kind != null ? !kind.equals(that.kind) :that.kind != null) return false;
        if (cachingMode != null ? !cachingMode.equals(that.cachingMode) :that.cachingMode != null) return false;
        if (fsType != null ? !fsType.equals(that.fsType) :that.fsType != null) return false;
        if (readOnly != null ? !readOnly.equals(that.readOnly) :that.readOnly != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  diskName,  diskURI,  kind,  cachingMode,  fsType,  readOnly,  super.hashCode());
    }

}
