package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class AzureDiskVolumeFluentImpl<A extends AzureDiskVolumeFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements AzureDiskVolumeFluent<A> {

    private String volumeName;
    private String diskName;
    private String diskURI;
    private String kind;
    private String cachingMode;
    private String fsType;
    private Boolean readOnly;

    public AzureDiskVolumeFluentImpl() {
    }

    public AzureDiskVolumeFluentImpl(io.dekorate.kubernetes.config.AzureDiskVolume instance) {
        this.withVolumeName(instance.getVolumeName()); 
        this.withDiskName(instance.getDiskName()); 
        this.withDiskURI(instance.getDiskURI()); 
        this.withKind(instance.getKind()); 
        this.withCachingMode(instance.getCachingMode()); 
        this.withFsType(instance.getFsType()); 
        this.withReadOnly(instance.getReadOnly()); 
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public A withVolumeName(String volumeName) {
        this.volumeName=volumeName; return (A) this;
    }

    public Boolean hasVolumeName() {
        return this.volumeName != null;
    }

    public A withNewVolumeName(String arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuilder arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuffer arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public String getDiskName() {
        return this.diskName;
    }

    public A withDiskName(String diskName) {
        this.diskName=diskName; return (A) this;
    }

    public Boolean hasDiskName() {
        return this.diskName != null;
    }

    public A withNewDiskName(String arg1) {
        return (A)withDiskName(new String(arg1));
    }

    public A withNewDiskName(StringBuilder arg1) {
        return (A)withDiskName(new String(arg1));
    }

    public A withNewDiskName(StringBuffer arg1) {
        return (A)withDiskName(new String(arg1));
    }

    public String getDiskURI() {
        return this.diskURI;
    }

    public A withDiskURI(String diskURI) {
        this.diskURI=diskURI; return (A) this;
    }

    public Boolean hasDiskURI() {
        return this.diskURI != null;
    }

    public A withNewDiskURI(String arg1) {
        return (A)withDiskURI(new String(arg1));
    }

    public A withNewDiskURI(StringBuilder arg1) {
        return (A)withDiskURI(new String(arg1));
    }

    public A withNewDiskURI(StringBuffer arg1) {
        return (A)withDiskURI(new String(arg1));
    }

    public String getKind() {
        return this.kind;
    }

    public A withKind(String kind) {
        this.kind=kind; return (A) this;
    }

    public Boolean hasKind() {
        return this.kind != null;
    }

    public A withNewKind(String arg1) {
        return (A)withKind(new String(arg1));
    }

    public A withNewKind(StringBuilder arg1) {
        return (A)withKind(new String(arg1));
    }

    public A withNewKind(StringBuffer arg1) {
        return (A)withKind(new String(arg1));
    }

    public String getCachingMode() {
        return this.cachingMode;
    }

    public A withCachingMode(String cachingMode) {
        this.cachingMode=cachingMode; return (A) this;
    }

    public Boolean hasCachingMode() {
        return this.cachingMode != null;
    }

    public A withNewCachingMode(String arg1) {
        return (A)withCachingMode(new String(arg1));
    }

    public A withNewCachingMode(StringBuilder arg1) {
        return (A)withCachingMode(new String(arg1));
    }

    public A withNewCachingMode(StringBuffer arg1) {
        return (A)withCachingMode(new String(arg1));
    }

    public String getFsType() {
        return this.fsType;
    }

    public A withFsType(String fsType) {
        this.fsType=fsType; return (A) this;
    }

    public Boolean hasFsType() {
        return this.fsType != null;
    }

    public A withNewFsType(String arg1) {
        return (A)withFsType(new String(arg1));
    }

    public A withNewFsType(StringBuilder arg1) {
        return (A)withFsType(new String(arg1));
    }

    public A withNewFsType(StringBuffer arg1) {
        return (A)withFsType(new String(arg1));
    }

    public Boolean getReadOnly() {
        return this.readOnly;
    }

    public A withReadOnly(Boolean readOnly) {
        this.readOnly=readOnly; return (A) this;
    }

    public Boolean hasReadOnly() {
        return this.readOnly != null;
    }

    public A withNewReadOnly(String arg1) {
        return (A)withReadOnly(new Boolean(arg1));
    }

    public A withNewReadOnly(boolean arg1) {
        return (A)withReadOnly(new Boolean(arg1));
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AzureDiskVolumeFluentImpl that = (AzureDiskVolumeFluentImpl) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (diskName != null ? !diskName.equals(that.diskName) :that.diskName != null) return false;
        if (diskURI != null ? !diskURI.equals(that.diskURI) :that.diskURI != null) return false;
        if (kind != null ? !kind.equals(that.kind) :that.kind != null) return false;
        if (cachingMode != null ? !cachingMode.equals(that.cachingMode) :that.cachingMode != null) return false;
        if (fsType != null ? !fsType.equals(that.fsType) :that.fsType != null) return false;
        if (readOnly != null ? !readOnly.equals(that.readOnly) :that.readOnly != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  diskName,  diskURI,  kind,  cachingMode,  fsType,  readOnly,  super.hashCode());
    }

}
