package io.dekorate.kubernetes.config;

import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class AzureFileVolume {

    private String volumeName;
    private String shareName;
    private String secretName;
    private Boolean readOnly;

    public AzureFileVolume() {
    }

    public AzureFileVolume(String volumeName,String shareName,String secretName,Boolean readOnly) {
        this.volumeName = volumeName;
        this.shareName = shareName;
        this.secretName = secretName;
        this.readOnly = readOnly;
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public String getShareName() {
        return this.shareName;
    }

    public String getSecretName() {
        return this.secretName;
    }

    public Boolean getReadOnly() {
        return this.readOnly;
    }

    public boolean isReadOnly() {
        return this.readOnly != null &&  this.readOnly;
    }

    public static AzureFileVolumeBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.AzureFileVolumeBuilder();
    }

    public static AzureFileVolumeBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.AzureFileVolumeBuilder().withReadOnly(false);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AzureFileVolume that = (AzureFileVolume) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (shareName != null ? !shareName.equals(that.shareName) :that.shareName != null) return false;
        if (secretName != null ? !secretName.equals(that.secretName) :that.secretName != null) return false;
        if (readOnly != null ? !readOnly.equals(that.readOnly) :that.readOnly != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  shareName,  secretName,  readOnly,  super.hashCode());
    }

}
