package io.dekorate.kubernetes.config;

import java.lang.String;
import io.dekorate.kubernetes.annotation.ServiceType;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;
import io.dekorate.project.Project;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import java.lang.Object;
import java.util.Map;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class BaseConfig extends ApplicationConfiguration {

    private io.dekorate.kubernetes.config.Label[] labels = new io.dekorate.kubernetes.config.Label[0];
    private io.dekorate.kubernetes.config.Annotation[] annotations = new io.dekorate.kubernetes.config.Annotation[0];
    private io.dekorate.kubernetes.config.Env[] envVars = new io.dekorate.kubernetes.config.Env[0];
    private String workingDir;
    private String[] command = new java.lang.String[0];
    private String[] arguments = new java.lang.String[0];
    private String serviceAccount;
    private String host;
    private io.dekorate.kubernetes.config.Port[] ports = new io.dekorate.kubernetes.config.Port[0];
    private ServiceType serviceType;
    private io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] pvcVolumes = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[0];
    private io.dekorate.kubernetes.config.SecretVolume[] secretVolumes = new io.dekorate.kubernetes.config.SecretVolume[0];
    private io.dekorate.kubernetes.config.ConfigMapVolume[] configMapVolumes = new io.dekorate.kubernetes.config.ConfigMapVolume[0];
    private io.dekorate.kubernetes.config.GitRepoVolume[] gitRepoVolumes = new io.dekorate.kubernetes.config.GitRepoVolume[0];
    private io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] awsElasticBlockStoreVolumes = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[0];
    private io.dekorate.kubernetes.config.AzureDiskVolume[] azureDiskVolumes = new io.dekorate.kubernetes.config.AzureDiskVolume[0];
    private io.dekorate.kubernetes.config.AzureFileVolume[] azureFileVolumes = new io.dekorate.kubernetes.config.AzureFileVolume[0];
    private io.dekorate.kubernetes.config.Mount[] mounts = new io.dekorate.kubernetes.config.Mount[0];
    private ImagePullPolicy imagePullPolicy;
    private String[] imagePullSecrets = new java.lang.String[0];
    private io.dekorate.kubernetes.config.HostAlias[] hostAliases = new io.dekorate.kubernetes.config.HostAlias[0];
    private io.dekorate.kubernetes.config.Probe livenessProbe;
    private io.dekorate.kubernetes.config.Probe readinessProbe;
    private io.dekorate.kubernetes.config.ResourceRequirements requestResources;
    private io.dekorate.kubernetes.config.ResourceRequirements limitResources;
    private io.dekorate.kubernetes.config.Container[] sidecars = new io.dekorate.kubernetes.config.Container[0];
    private Boolean expose;
    private Boolean autoDeployEnabled;

    public BaseConfig() {
    }

    public BaseConfig(Project project,Map<ConfigKey,Object> attributes,String partOf,String name,String version,io.dekorate.kubernetes.config.Label[] labels,io.dekorate.kubernetes.config.Annotation[] annotations,io.dekorate.kubernetes.config.Env[] envVars,String workingDir,String[] command,String[] arguments,String serviceAccount,String host,io.dekorate.kubernetes.config.Port[] ports,ServiceType serviceType,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] pvcVolumes,io.dekorate.kubernetes.config.SecretVolume[] secretVolumes,io.dekorate.kubernetes.config.ConfigMapVolume[] configMapVolumes,io.dekorate.kubernetes.config.GitRepoVolume[] gitRepoVolumes,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] awsElasticBlockStoreVolumes,io.dekorate.kubernetes.config.AzureDiskVolume[] azureDiskVolumes,io.dekorate.kubernetes.config.AzureFileVolume[] azureFileVolumes,io.dekorate.kubernetes.config.Mount[] mounts,ImagePullPolicy imagePullPolicy,String[] imagePullSecrets,io.dekorate.kubernetes.config.HostAlias[] hostAliases,io.dekorate.kubernetes.config.Probe livenessProbe,io.dekorate.kubernetes.config.Probe readinessProbe,io.dekorate.kubernetes.config.ResourceRequirements requestResources,io.dekorate.kubernetes.config.ResourceRequirements limitResources,io.dekorate.kubernetes.config.Container[] sidecars,Boolean expose,Boolean autoDeployEnabled) {
        super(project, attributes, partOf, name, version);
        this.labels = labels != null ? labels : new io.dekorate.kubernetes.config.Label[0];
        this.annotations = annotations != null ? annotations : new io.dekorate.kubernetes.config.Annotation[0];
        this.envVars = envVars != null ? envVars : new io.dekorate.kubernetes.config.Env[0];
        this.workingDir = workingDir;
        this.command = command != null ? command : new java.lang.String[0];
        this.arguments = arguments != null ? arguments : new java.lang.String[0];
        this.serviceAccount = serviceAccount;
        this.host = host;
        this.ports = ports != null ? ports : new io.dekorate.kubernetes.config.Port[0];
        this.serviceType = serviceType;
        this.pvcVolumes = pvcVolumes != null ? pvcVolumes : new io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[0];
        this.secretVolumes = secretVolumes != null ? secretVolumes : new io.dekorate.kubernetes.config.SecretVolume[0];
        this.configMapVolumes = configMapVolumes != null ? configMapVolumes : new io.dekorate.kubernetes.config.ConfigMapVolume[0];
        this.gitRepoVolumes = gitRepoVolumes != null ? gitRepoVolumes : new io.dekorate.kubernetes.config.GitRepoVolume[0];
        this.awsElasticBlockStoreVolumes = awsElasticBlockStoreVolumes != null ? awsElasticBlockStoreVolumes : new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[0];
        this.azureDiskVolumes = azureDiskVolumes != null ? azureDiskVolumes : new io.dekorate.kubernetes.config.AzureDiskVolume[0];
        this.azureFileVolumes = azureFileVolumes != null ? azureFileVolumes : new io.dekorate.kubernetes.config.AzureFileVolume[0];
        this.mounts = mounts != null ? mounts : new io.dekorate.kubernetes.config.Mount[0];
        this.imagePullPolicy = imagePullPolicy;
        this.imagePullSecrets = imagePullSecrets != null ? imagePullSecrets : new java.lang.String[0];
        this.hostAliases = hostAliases != null ? hostAliases : new io.dekorate.kubernetes.config.HostAlias[0];
        this.livenessProbe = livenessProbe;
        this.readinessProbe = readinessProbe;
        this.requestResources = requestResources;
        this.limitResources = limitResources;
        this.sidecars = sidecars != null ? sidecars : new io.dekorate.kubernetes.config.Container[0];
        this.expose = expose;
        this.autoDeployEnabled = autoDeployEnabled;
    }

    public io.dekorate.kubernetes.config.Label[] getLabels() {
        return this.labels;
    }

    public io.dekorate.kubernetes.config.Annotation[] getAnnotations() {
        return this.annotations;
    }

    public io.dekorate.kubernetes.config.Env[] getEnvVars() {
        return this.envVars;
    }

    public String getWorkingDir() {
        return this.workingDir;
    }

    public String[] getCommand() {
        return this.command;
    }

    public String[] getArguments() {
        return this.arguments;
    }

    public String getServiceAccount() {
        return this.serviceAccount;
    }

    public String getHost() {
        return this.host;
    }

    public io.dekorate.kubernetes.config.Port[] getPorts() {
        return this.ports;
    }

    public ServiceType getServiceType() {
        return this.serviceType;
    }

    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] getPvcVolumes() {
        return this.pvcVolumes;
    }

    public io.dekorate.kubernetes.config.SecretVolume[] getSecretVolumes() {
        return this.secretVolumes;
    }

    public io.dekorate.kubernetes.config.ConfigMapVolume[] getConfigMapVolumes() {
        return this.configMapVolumes;
    }

    public io.dekorate.kubernetes.config.GitRepoVolume[] getGitRepoVolumes() {
        return this.gitRepoVolumes;
    }

    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] getAwsElasticBlockStoreVolumes() {
        return this.awsElasticBlockStoreVolumes;
    }

    public io.dekorate.kubernetes.config.AzureDiskVolume[] getAzureDiskVolumes() {
        return this.azureDiskVolumes;
    }

    public io.dekorate.kubernetes.config.AzureFileVolume[] getAzureFileVolumes() {
        return this.azureFileVolumes;
    }

    public io.dekorate.kubernetes.config.Mount[] getMounts() {
        return this.mounts;
    }

    public ImagePullPolicy getImagePullPolicy() {
        return this.imagePullPolicy;
    }

    public String[] getImagePullSecrets() {
        return this.imagePullSecrets;
    }

    public io.dekorate.kubernetes.config.HostAlias[] getHostAliases() {
        return this.hostAliases;
    }

    public io.dekorate.kubernetes.config.Probe getLivenessProbe() {
        return this.livenessProbe;
    }

    public io.dekorate.kubernetes.config.Probe getReadinessProbe() {
        return this.readinessProbe;
    }

    public io.dekorate.kubernetes.config.ResourceRequirements getRequestResources() {
        return this.requestResources;
    }

    public io.dekorate.kubernetes.config.ResourceRequirements getLimitResources() {
        return this.limitResources;
    }

    public io.dekorate.kubernetes.config.Container[] getSidecars() {
        return this.sidecars;
    }

    public Boolean getExpose() {
        return this.expose;
    }

    public boolean isExpose() {
        return this.expose != null &&  this.expose;
    }

    public Boolean getAutoDeployEnabled() {
        return this.autoDeployEnabled;
    }

    public boolean isAutoDeployEnabled() {
        return this.autoDeployEnabled != null &&  this.autoDeployEnabled;
    }

    public static BaseConfigBuilder newBaseConfigBuilder() {
        return new io.dekorate.kubernetes.config.BaseConfigBuilder();
    }

    public static BaseConfigBuilder newBaseConfigBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.BaseConfigBuilder().withServiceType(io.dekorate.kubernetes.annotation.ServiceType.ClusterIP).withImagePullPolicy(io.dekorate.kubernetes.annotation.ImagePullPolicy.IfNotPresent).withLivenessProbe(new io.dekorate.kubernetes.config.Probe()).withReadinessProbe(new io.dekorate.kubernetes.config.Probe()).withRequestResources(new io.dekorate.kubernetes.config.ResourceRequirements()).withLimitResources(new io.dekorate.kubernetes.config.ResourceRequirements()).withExpose(false).withAutoDeployEnabled(false);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        BaseConfig that = (BaseConfig) o;
        if (labels != null ? !labels.equals(that.labels) :that.labels != null) return false;
        if (annotations != null ? !annotations.equals(that.annotations) :that.annotations != null) return false;
        if (envVars != null ? !envVars.equals(that.envVars) :that.envVars != null) return false;
        if (workingDir != null ? !workingDir.equals(that.workingDir) :that.workingDir != null) return false;
        if (command != null ? !command.equals(that.command) :that.command != null) return false;
        if (arguments != null ? !arguments.equals(that.arguments) :that.arguments != null) return false;
        if (serviceAccount != null ? !serviceAccount.equals(that.serviceAccount) :that.serviceAccount != null) return false;
        if (host != null ? !host.equals(that.host) :that.host != null) return false;
        if (ports != null ? !ports.equals(that.ports) :that.ports != null) return false;
        if (serviceType != null ? !serviceType.equals(that.serviceType) :that.serviceType != null) return false;
        if (pvcVolumes != null ? !pvcVolumes.equals(that.pvcVolumes) :that.pvcVolumes != null) return false;
        if (secretVolumes != null ? !secretVolumes.equals(that.secretVolumes) :that.secretVolumes != null) return false;
        if (configMapVolumes != null ? !configMapVolumes.equals(that.configMapVolumes) :that.configMapVolumes != null) return false;
        if (gitRepoVolumes != null ? !gitRepoVolumes.equals(that.gitRepoVolumes) :that.gitRepoVolumes != null) return false;
        if (awsElasticBlockStoreVolumes != null ? !awsElasticBlockStoreVolumes.equals(that.awsElasticBlockStoreVolumes) :that.awsElasticBlockStoreVolumes != null) return false;
        if (azureDiskVolumes != null ? !azureDiskVolumes.equals(that.azureDiskVolumes) :that.azureDiskVolumes != null) return false;
        if (azureFileVolumes != null ? !azureFileVolumes.equals(that.azureFileVolumes) :that.azureFileVolumes != null) return false;
        if (mounts != null ? !mounts.equals(that.mounts) :that.mounts != null) return false;
        if (imagePullPolicy != null ? !imagePullPolicy.equals(that.imagePullPolicy) :that.imagePullPolicy != null) return false;
        if (imagePullSecrets != null ? !imagePullSecrets.equals(that.imagePullSecrets) :that.imagePullSecrets != null) return false;
        if (hostAliases != null ? !hostAliases.equals(that.hostAliases) :that.hostAliases != null) return false;
        if (livenessProbe != null ? !livenessProbe.equals(that.livenessProbe) :that.livenessProbe != null) return false;
        if (readinessProbe != null ? !readinessProbe.equals(that.readinessProbe) :that.readinessProbe != null) return false;
        if (requestResources != null ? !requestResources.equals(that.requestResources) :that.requestResources != null) return false;
        if (limitResources != null ? !limitResources.equals(that.limitResources) :that.limitResources != null) return false;
        if (sidecars != null ? !sidecars.equals(that.sidecars) :that.sidecars != null) return false;
        if (expose != null ? !expose.equals(that.expose) :that.expose != null) return false;
        if (autoDeployEnabled != null ? !autoDeployEnabled.equals(that.autoDeployEnabled) :that.autoDeployEnabled != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(labels,  annotations,  envVars,  workingDir,  command,  arguments,  serviceAccount,  host,  ports,  serviceType,  pvcVolumes,  secretVolumes,  configMapVolumes,  gitRepoVolumes,  awsElasticBlockStoreVolumes,  azureDiskVolumes,  azureFileVolumes,  mounts,  imagePullPolicy,  imagePullSecrets,  hostAliases,  livenessProbe,  readinessProbe,  requestResources,  limitResources,  sidecars,  expose,  autoDeployEnabled,  super.hashCode());
    }

}
