package io.dekorate.kubernetes.config;

import java.lang.Integer;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class ConfigMapVolume {

    private String volumeName;
    private String configMapName;
    private Integer defaultMode;
    private Boolean optional;

    public ConfigMapVolume() {
    }

    public ConfigMapVolume(String volumeName,String configMapName,Integer defaultMode,Boolean optional) {
        this.volumeName = volumeName;
        this.configMapName = configMapName;
        this.defaultMode = defaultMode;
        this.optional = optional;
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public String getConfigMapName() {
        return this.configMapName;
    }

    public Integer getDefaultMode() {
        return this.defaultMode;
    }

    public Boolean getOptional() {
        return this.optional;
    }

    public boolean isOptional() {
        return this.optional != null &&  this.optional;
    }

    public static ConfigMapVolumeBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.ConfigMapVolumeBuilder();
    }

    public static ConfigMapVolumeBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.ConfigMapVolumeBuilder().withDefaultMode(384).withOptional(false);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ConfigMapVolume that = (ConfigMapVolume) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (configMapName != null ? !configMapName.equals(that.configMapName) :that.configMapName != null) return false;
        if (defaultMode != null ? !defaultMode.equals(that.defaultMode) :that.defaultMode != null) return false;
        if (optional != null ? !optional.equals(that.optional) :that.optional != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  configMapName,  defaultMode,  optional,  super.hashCode());
    }

}
