package io.dekorate.kubernetes.config;

import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import java.lang.Object;
import java.lang.String;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class Container {

    private String image;
    private String name;
    private io.dekorate.kubernetes.config.Env[] envVars = new io.dekorate.kubernetes.config.Env[0];
    private String workingDir;
    private String[] command = new java.lang.String[0];
    private String[] arguments = new java.lang.String[0];
    private io.dekorate.kubernetes.config.Port[] ports = new io.dekorate.kubernetes.config.Port[0];
    private io.dekorate.kubernetes.config.Mount[] mounts = new io.dekorate.kubernetes.config.Mount[0];
    private ImagePullPolicy imagePullPolicy;
    private io.dekorate.kubernetes.config.Probe livenessProbe;
    private io.dekorate.kubernetes.config.Probe readinessProbe;
    private io.dekorate.kubernetes.config.ResourceRequirements requestResources;
    private io.dekorate.kubernetes.config.ResourceRequirements limitResources;

    public Container() {
    }

    public Container(String image,String name,io.dekorate.kubernetes.config.Env[] envVars,String workingDir,String[] command,String[] arguments,io.dekorate.kubernetes.config.Port[] ports,io.dekorate.kubernetes.config.Mount[] mounts,ImagePullPolicy imagePullPolicy,io.dekorate.kubernetes.config.Probe livenessProbe,io.dekorate.kubernetes.config.Probe readinessProbe,io.dekorate.kubernetes.config.ResourceRequirements requestResources,io.dekorate.kubernetes.config.ResourceRequirements limitResources) {
        this.image = image;
        this.name = name;
        this.envVars = envVars != null ? envVars : new io.dekorate.kubernetes.config.Env[0];
        this.workingDir = workingDir;
        this.command = command != null ? command : new java.lang.String[0];
        this.arguments = arguments != null ? arguments : new java.lang.String[0];
        this.ports = ports != null ? ports : new io.dekorate.kubernetes.config.Port[0];
        this.mounts = mounts != null ? mounts : new io.dekorate.kubernetes.config.Mount[0];
        this.imagePullPolicy = imagePullPolicy;
        this.livenessProbe = livenessProbe;
        this.readinessProbe = readinessProbe;
        this.requestResources = requestResources;
        this.limitResources = limitResources;
    }

    public String getImage() {
        return this.image;
    }

    public String getName() {
        return this.name;
    }

    public io.dekorate.kubernetes.config.Env[] getEnvVars() {
        return this.envVars;
    }

    public String getWorkingDir() {
        return this.workingDir;
    }

    public String[] getCommand() {
        return this.command;
    }

    public String[] getArguments() {
        return this.arguments;
    }

    public io.dekorate.kubernetes.config.Port[] getPorts() {
        return this.ports;
    }

    public io.dekorate.kubernetes.config.Mount[] getMounts() {
        return this.mounts;
    }

    public ImagePullPolicy getImagePullPolicy() {
        return this.imagePullPolicy;
    }

    public io.dekorate.kubernetes.config.Probe getLivenessProbe() {
        return this.livenessProbe;
    }

    public io.dekorate.kubernetes.config.Probe getReadinessProbe() {
        return this.readinessProbe;
    }

    public io.dekorate.kubernetes.config.ResourceRequirements getRequestResources() {
        return this.requestResources;
    }

    public io.dekorate.kubernetes.config.ResourceRequirements getLimitResources() {
        return this.limitResources;
    }

    public static ContainerBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.ContainerBuilder();
    }

    public static ContainerBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.ContainerBuilder().withImagePullPolicy(io.dekorate.kubernetes.annotation.ImagePullPolicy.IfNotPresent).withLivenessProbe(new io.dekorate.kubernetes.config.Probe()).withReadinessProbe(new io.dekorate.kubernetes.config.Probe()).withRequestResources(new io.dekorate.kubernetes.config.ResourceRequirements()).withLimitResources(new io.dekorate.kubernetes.config.ResourceRequirements());
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Container that = (Container) o;
        if (image != null ? !image.equals(that.image) :that.image != null) return false;
        if (name != null ? !name.equals(that.name) :that.name != null) return false;
        if (envVars != null ? !envVars.equals(that.envVars) :that.envVars != null) return false;
        if (workingDir != null ? !workingDir.equals(that.workingDir) :that.workingDir != null) return false;
        if (command != null ? !command.equals(that.command) :that.command != null) return false;
        if (arguments != null ? !arguments.equals(that.arguments) :that.arguments != null) return false;
        if (ports != null ? !ports.equals(that.ports) :that.ports != null) return false;
        if (mounts != null ? !mounts.equals(that.mounts) :that.mounts != null) return false;
        if (imagePullPolicy != null ? !imagePullPolicy.equals(that.imagePullPolicy) :that.imagePullPolicy != null) return false;
        if (livenessProbe != null ? !livenessProbe.equals(that.livenessProbe) :that.livenessProbe != null) return false;
        if (readinessProbe != null ? !readinessProbe.equals(that.readinessProbe) :that.readinessProbe != null) return false;
        if (requestResources != null ? !requestResources.equals(that.requestResources) :that.requestResources != null) return false;
        if (limitResources != null ? !limitResources.equals(that.limitResources) :that.limitResources != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(image,  name,  envVars,  workingDir,  command,  arguments,  ports,  mounts,  imagePullPolicy,  livenessProbe,  readinessProbe,  requestResources,  limitResources,  super.hashCode());
    }

}
