package io.dekorate.kubernetes.config;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Deprecated;
import java.util.Iterator;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.StringBuffer;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import java.util.Collection;

public interface ContainerFluent<A extends ContainerFluent<A>> extends Fluent<A> {


    public String getImage();
    public A withImage(String image);
    public Boolean hasImage();
    public A withNewImage(String arg1);
    public A withNewImage(StringBuilder arg1);
    public A withNewImage(StringBuffer arg1);
    public String getName();
    public A withName(String name);
    public Boolean hasName();
    public A withNewName(String arg1);
    public A withNewName(StringBuilder arg1);
    public A withNewName(StringBuffer arg1);
    public A withEnvVars(io.dekorate.kubernetes.config.Env... envVars);
    
/**
 * This method has been deprecated, please use method buildEnvVars instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Env[] getEnvVars();
    public io.dekorate.kubernetes.config.Env[] buildEnvVars();
    public io.dekorate.kubernetes.config.Env buildEnvVar(int index);
    public io.dekorate.kubernetes.config.Env buildFirstEnvVar();
    public io.dekorate.kubernetes.config.Env buildLastEnvVar();
    public io.dekorate.kubernetes.config.Env buildMatchingEnvVar(Predicate<EnvBuilder> predicate);
    public Boolean hasMatchingEnvVar(Predicate<EnvBuilder> predicate);
    public A addToEnvVars(int index,io.dekorate.kubernetes.config.Env item);
    public A setToEnvVars(int index,io.dekorate.kubernetes.config.Env item);
    public A addToEnvVars(io.dekorate.kubernetes.config.Env... items);
    public A addAllToEnvVars(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeFromEnvVars(io.dekorate.kubernetes.config.Env... items);
    public A removeAllFromEnvVars(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeMatchingFromEnvVars(Predicate<EnvBuilder> predicate);
    public Boolean hasEnvVars();
    public ContainerFluent.EnvVarsNested<A> addNewEnvVar();
    public ContainerFluent.EnvVarsNested<A> addNewEnvVarLike(io.dekorate.kubernetes.config.Env item);
    public ContainerFluent.EnvVarsNested<A> setNewEnvVarLike(int index,io.dekorate.kubernetes.config.Env item);
    public ContainerFluent.EnvVarsNested<A> editEnvVar(int index);
    public ContainerFluent.EnvVarsNested<A> editFirstEnvVar();
    public ContainerFluent.EnvVarsNested<A> editLastEnvVar();
    public ContainerFluent.EnvVarsNested<A> editMatchingEnvVar(Predicate<EnvBuilder> predicate);
    public String getWorkingDir();
    public A withWorkingDir(String workingDir);
    public Boolean hasWorkingDir();
    public A withNewWorkingDir(String arg1);
    public A withNewWorkingDir(StringBuilder arg1);
    public A withNewWorkingDir(StringBuffer arg1);
    public A withCommand(String... command);
    public String[] getCommand();
    public A addToCommand(int index,String item);
    public A setToCommand(int index,String item);
    public A addToCommand(String... items);
    public A addAllToCommand(Collection<String> items);
    public A removeFromCommand(String... items);
    public A removeAllFromCommand(Collection<String> items);
    public Boolean hasCommand();
    public A addNewCommand(String arg1);
    public A addNewCommand(StringBuilder arg1);
    public A addNewCommand(StringBuffer arg1);
    public A withArguments(String... arguments);
    public String[] getArguments();
    public A addToArguments(int index,String item);
    public A setToArguments(int index,String item);
    public A addToArguments(String... items);
    public A addAllToArguments(Collection<String> items);
    public A removeFromArguments(String... items);
    public A removeAllFromArguments(Collection<String> items);
    public Boolean hasArguments();
    public A addNewArgument(String arg1);
    public A addNewArgument(StringBuilder arg1);
    public A addNewArgument(StringBuffer arg1);
    public A withPorts(io.dekorate.kubernetes.config.Port... ports);
    
/**
 * This method has been deprecated, please use method buildPorts instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Port[] getPorts();
    public io.dekorate.kubernetes.config.Port[] buildPorts();
    public io.dekorate.kubernetes.config.Port buildPort(int index);
    public io.dekorate.kubernetes.config.Port buildFirstPort();
    public io.dekorate.kubernetes.config.Port buildLastPort();
    public io.dekorate.kubernetes.config.Port buildMatchingPort(Predicate<PortBuilder> predicate);
    public Boolean hasMatchingPort(Predicate<PortBuilder> predicate);
    public A addToPorts(int index,io.dekorate.kubernetes.config.Port item);
    public A setToPorts(int index,io.dekorate.kubernetes.config.Port item);
    public A addToPorts(io.dekorate.kubernetes.config.Port... items);
    public A addAllToPorts(Collection<io.dekorate.kubernetes.config.Port> items);
    public A removeFromPorts(io.dekorate.kubernetes.config.Port... items);
    public A removeAllFromPorts(Collection<io.dekorate.kubernetes.config.Port> items);
    public A removeMatchingFromPorts(Predicate<PortBuilder> predicate);
    public Boolean hasPorts();
    public ContainerFluent.PortsNested<A> addNewPort();
    public ContainerFluent.PortsNested<A> addNewPortLike(io.dekorate.kubernetes.config.Port item);
    public ContainerFluent.PortsNested<A> setNewPortLike(int index,io.dekorate.kubernetes.config.Port item);
    public ContainerFluent.PortsNested<A> editPort(int index);
    public ContainerFluent.PortsNested<A> editFirstPort();
    public ContainerFluent.PortsNested<A> editLastPort();
    public ContainerFluent.PortsNested<A> editMatchingPort(Predicate<PortBuilder> predicate);
    public A withMounts(io.dekorate.kubernetes.config.Mount... mounts);
    
/**
 * This method has been deprecated, please use method buildMounts instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Mount[] getMounts();
    public io.dekorate.kubernetes.config.Mount[] buildMounts();
    public io.dekorate.kubernetes.config.Mount buildMount(int index);
    public io.dekorate.kubernetes.config.Mount buildFirstMount();
    public io.dekorate.kubernetes.config.Mount buildLastMount();
    public io.dekorate.kubernetes.config.Mount buildMatchingMount(Predicate<MountBuilder> predicate);
    public Boolean hasMatchingMount(Predicate<MountBuilder> predicate);
    public A addToMounts(int index,io.dekorate.kubernetes.config.Mount item);
    public A setToMounts(int index,io.dekorate.kubernetes.config.Mount item);
    public A addToMounts(io.dekorate.kubernetes.config.Mount... items);
    public A addAllToMounts(Collection<io.dekorate.kubernetes.config.Mount> items);
    public A removeFromMounts(io.dekorate.kubernetes.config.Mount... items);
    public A removeAllFromMounts(Collection<io.dekorate.kubernetes.config.Mount> items);
    public A removeMatchingFromMounts(Predicate<MountBuilder> predicate);
    public Boolean hasMounts();
    public A addNewMount(String name,String path,String subPath,Boolean readOnly);
    public ContainerFluent.MountsNested<A> addNewMount();
    public ContainerFluent.MountsNested<A> addNewMountLike(io.dekorate.kubernetes.config.Mount item);
    public ContainerFluent.MountsNested<A> setNewMountLike(int index,io.dekorate.kubernetes.config.Mount item);
    public ContainerFluent.MountsNested<A> editMount(int index);
    public ContainerFluent.MountsNested<A> editFirstMount();
    public ContainerFluent.MountsNested<A> editLastMount();
    public ContainerFluent.MountsNested<A> editMatchingMount(Predicate<MountBuilder> predicate);
    public ImagePullPolicy getImagePullPolicy();
    public A withImagePullPolicy(ImagePullPolicy imagePullPolicy);
    public Boolean hasImagePullPolicy();
    
/**
 * This method has been deprecated, please use method buildLivenessProbe instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.kubernetes.config.Probe getLivenessProbe();
    public io.dekorate.kubernetes.config.Probe buildLivenessProbe();
    public A withLivenessProbe(io.dekorate.kubernetes.config.Probe livenessProbe);
    public Boolean hasLivenessProbe();
    public ContainerFluent.LivenessProbeNested<A> withNewLivenessProbe();
    public ContainerFluent.LivenessProbeNested<A> withNewLivenessProbeLike(io.dekorate.kubernetes.config.Probe item);
    public ContainerFluent.LivenessProbeNested<A> editLivenessProbe();
    public ContainerFluent.LivenessProbeNested<A> editOrNewLivenessProbe();
    public ContainerFluent.LivenessProbeNested<A> editOrNewLivenessProbeLike(io.dekorate.kubernetes.config.Probe item);
    
/**
 * This method has been deprecated, please use method buildReadinessProbe instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.kubernetes.config.Probe getReadinessProbe();
    public io.dekorate.kubernetes.config.Probe buildReadinessProbe();
    public A withReadinessProbe(io.dekorate.kubernetes.config.Probe readinessProbe);
    public Boolean hasReadinessProbe();
    public ContainerFluent.ReadinessProbeNested<A> withNewReadinessProbe();
    public ContainerFluent.ReadinessProbeNested<A> withNewReadinessProbeLike(io.dekorate.kubernetes.config.Probe item);
    public ContainerFluent.ReadinessProbeNested<A> editReadinessProbe();
    public ContainerFluent.ReadinessProbeNested<A> editOrNewReadinessProbe();
    public ContainerFluent.ReadinessProbeNested<A> editOrNewReadinessProbeLike(io.dekorate.kubernetes.config.Probe item);
    
/**
 * This method has been deprecated, please use method buildRequestResources instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.kubernetes.config.ResourceRequirements getRequestResources();
    public io.dekorate.kubernetes.config.ResourceRequirements buildRequestResources();
    public A withRequestResources(io.dekorate.kubernetes.config.ResourceRequirements requestResources);
    public Boolean hasRequestResources();
    public A withNewRequestResources(String memory,String cpu);
    public ContainerFluent.RequestResourcesNested<A> withNewRequestResources();
    public ContainerFluent.RequestResourcesNested<A> withNewRequestResourcesLike(io.dekorate.kubernetes.config.ResourceRequirements item);
    public ContainerFluent.RequestResourcesNested<A> editRequestResources();
    public ContainerFluent.RequestResourcesNested<A> editOrNewRequestResources();
    public ContainerFluent.RequestResourcesNested<A> editOrNewRequestResourcesLike(io.dekorate.kubernetes.config.ResourceRequirements item);
    
/**
 * This method has been deprecated, please use method buildLimitResources instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.kubernetes.config.ResourceRequirements getLimitResources();
    public io.dekorate.kubernetes.config.ResourceRequirements buildLimitResources();
    public A withLimitResources(io.dekorate.kubernetes.config.ResourceRequirements limitResources);
    public Boolean hasLimitResources();
    public A withNewLimitResources(String memory,String cpu);
    public ContainerFluent.LimitResourcesNested<A> withNewLimitResources();
    public ContainerFluent.LimitResourcesNested<A> withNewLimitResourcesLike(io.dekorate.kubernetes.config.ResourceRequirements item);
    public ContainerFluent.LimitResourcesNested<A> editLimitResources();
    public ContainerFluent.LimitResourcesNested<A> editOrNewLimitResources();
    public ContainerFluent.LimitResourcesNested<A> editOrNewLimitResourcesLike(io.dekorate.kubernetes.config.ResourceRequirements item);
    public interface EnvVarsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,EnvFluent<ContainerFluent.EnvVarsNested<N>> {

            public N and();
            public N endEnvVar();    }


    public interface PortsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PortFluent<ContainerFluent.PortsNested<N>> {

            public N and();
            public N endPort();    }


    public interface MountsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,MountFluent<ContainerFluent.MountsNested<N>> {

            public N and();
            public N endMount();    }


    public interface LivenessProbeNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ProbeFluent<ContainerFluent.LivenessProbeNested<N>> {

            public N and();
            public N endLivenessProbe();    }


    public interface ReadinessProbeNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ProbeFluent<ContainerFluent.ReadinessProbeNested<N>> {

            public N and();
            public N endReadinessProbe();    }


    public interface RequestResourcesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ResourceRequirementsFluent<ContainerFluent.RequestResourcesNested<N>> {

            public N and();
            public N endRequestResources();    }


    public interface LimitResourcesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ResourceRequirementsFluent<ContainerFluent.LimitResourcesNested<N>> {

            public N and();
            public N endLimitResources();    }


}
