package io.dekorate.kubernetes.config;

import java.lang.Object;
import java.lang.String;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class Env {

    private String name;
    private String value;
    private String secret;
    private String configmap;
    private String field;
    private String resourceField;

    public Env() {
    }

    public Env(String name,String value,String secret,String configmap,String field,String resourceField) {
        this.name = name;
        this.value = value;
        this.secret = secret;
        this.configmap = configmap;
        this.field = field;
        this.resourceField = resourceField;
    }

    public String getName() {
        return this.name;
    }

    public String getValue() {
        return this.value;
    }

    public String getSecret() {
        return this.secret;
    }

    public String getConfigmap() {
        return this.configmap;
    }

    public String getField() {
        return this.field;
    }

    public String getResourceField() {
        return this.resourceField;
    }

    public static EnvBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.EnvBuilder();
    }

    public static EnvBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.EnvBuilder();
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Env that = (Env) o;
        if (name != null ? !name.equals(that.name) :that.name != null) return false;
        if (value != null ? !value.equals(that.value) :that.value != null) return false;
        if (secret != null ? !secret.equals(that.secret) :that.secret != null) return false;
        if (configmap != null ? !configmap.equals(that.configmap) :that.configmap != null) return false;
        if (field != null ? !field.equals(that.field) :that.field != null) return false;
        if (resourceField != null ? !resourceField.equals(that.resourceField) :that.resourceField != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(name,  value,  secret,  configmap,  field,  resourceField,  super.hashCode());
    }

}
