package io.dekorate.kubernetes.config;

import java.lang.Object;
import java.lang.String;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class GitRepoVolume {

    private String volumeName;
    private String repository;
    private String directory;
    private String revision;

    public GitRepoVolume() {
    }

    public GitRepoVolume(String volumeName,String repository,String directory,String revision) {
        this.volumeName = volumeName;
        this.repository = repository;
        this.directory = directory;
        this.revision = revision;
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public String getRepository() {
        return this.repository;
    }

    public String getDirectory() {
        return this.directory;
    }

    public String getRevision() {
        return this.revision;
    }

    public static GitRepoVolumeBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.GitRepoVolumeBuilder();
    }

    public static GitRepoVolumeBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.GitRepoVolumeBuilder();
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        GitRepoVolume that = (GitRepoVolume) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (repository != null ? !repository.equals(that.repository) :that.repository != null) return false;
        if (directory != null ? !directory.equals(that.directory) :that.directory != null) return false;
        if (revision != null ? !revision.equals(that.revision) :that.revision != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  repository,  directory,  revision,  super.hashCode());
    }

}
