package io.dekorate.kubernetes.config;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class HostAliasBuilder extends HostAliasFluentImpl<HostAliasBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.HostAlias,HostAliasBuilder> {

    HostAliasFluent<?> fluent;
    Boolean validationEnabled;

    public HostAliasBuilder() {
        this(true);
    }

    public HostAliasBuilder(Boolean validationEnabled) {
        this(new HostAlias(), validationEnabled);
    }

    public HostAliasBuilder(HostAliasFluent<?> fluent) {
        this(fluent, true);
    }

    public HostAliasBuilder(HostAliasFluent<?> fluent,Boolean validationEnabled) {
        this(fluent, new HostAlias(), validationEnabled);
    }

    public HostAliasBuilder(HostAliasFluent<?> fluent,io.dekorate.kubernetes.config.HostAlias instance) {
        this(fluent, instance, true);
    }

    public HostAliasBuilder(HostAliasFluent<?> fluent,io.dekorate.kubernetes.config.HostAlias instance,Boolean validationEnabled) {
        this.fluent = fluent; 
        fluent.withIp(instance.getIp()); 
        fluent.withHostnames(instance.getHostnames()); 
        this.validationEnabled = validationEnabled; 
    }

    public HostAliasBuilder(io.dekorate.kubernetes.config.HostAlias instance) {
        this(instance,true);
    }

    public HostAliasBuilder(io.dekorate.kubernetes.config.HostAlias instance,Boolean validationEnabled) {
        this.fluent = this; 
        this.withIp(instance.getIp()); 
        this.withHostnames(instance.getHostnames()); 
        this.validationEnabled = validationEnabled; 
    }

    public EditableHostAlias build() {
        EditableHostAlias buildable = new EditableHostAlias(fluent.getIp(),fluent.getHostnames());
        return buildable;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        HostAliasBuilder that = (HostAliasBuilder) o;
        if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;
        
        if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
    }

}
