package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class ImageConfigurationFluentImpl<A extends ImageConfigurationFluent<A>> extends ApplicationConfigurationFluentImpl<A> implements ImageConfigurationFluent<A> {

    private String registry;
    private String group;
    private String name;
    private String version;
    private String image;
    private String dockerFile;
    private Boolean autoBuildEnabled;
    private Boolean autoPushEnabled;

    public ImageConfigurationFluentImpl() {
    }

    public ImageConfigurationFluentImpl(ImageConfiguration instance) {
        this.withProject(instance.getProject()); 
        this.withAttributes(instance.getAttributes()); 
        this.withRegistry(instance.getRegistry()); 
        this.withGroup(instance.getGroup()); 
        this.withName(instance.getName()); 
        this.withVersion(instance.getVersion()); 
        this.withImage(instance.getImage()); 
        this.withDockerFile(instance.getDockerFile()); 
        this.withAutoBuildEnabled(instance.getAutoBuildEnabled()); 
        this.withAutoPushEnabled(instance.getAutoPushEnabled()); 
    }

    public String getRegistry() {
        return this.registry;
    }

    public A withRegistry(String registry) {
        this.registry=registry; return (A) this;
    }

    public Boolean hasRegistry() {
        return this.registry != null;
    }

    public A withNewRegistry(String arg1) {
        return (A)withRegistry(new String(arg1));
    }

    public A withNewRegistry(StringBuilder arg1) {
        return (A)withRegistry(new String(arg1));
    }

    public A withNewRegistry(StringBuffer arg1) {
        return (A)withRegistry(new String(arg1));
    }

    public String getGroup() {
        return this.group;
    }

    public A withGroup(String group) {
        this.group=group; return (A) this;
    }

    public Boolean hasGroup() {
        return this.group != null;
    }

    public A withNewGroup(String arg1) {
        return (A)withGroup(new String(arg1));
    }

    public A withNewGroup(StringBuilder arg1) {
        return (A)withGroup(new String(arg1));
    }

    public A withNewGroup(StringBuffer arg1) {
        return (A)withGroup(new String(arg1));
    }

    public String getName() {
        return this.name;
    }

    public A withName(String name) {
        this.name=name; return (A) this;
    }

    public Boolean hasName() {
        return this.name != null;
    }

    public A withNewName(String arg1) {
        return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuilder arg1) {
        return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuffer arg1) {
        return (A)withName(new String(arg1));
    }

    public String getVersion() {
        return this.version;
    }

    public A withVersion(String version) {
        this.version=version; return (A) this;
    }

    public Boolean hasVersion() {
        return this.version != null;
    }

    public A withNewVersion(String arg1) {
        return (A)withVersion(new String(arg1));
    }

    public A withNewVersion(StringBuilder arg1) {
        return (A)withVersion(new String(arg1));
    }

    public A withNewVersion(StringBuffer arg1) {
        return (A)withVersion(new String(arg1));
    }

    public String getImage() {
        return this.image;
    }

    public A withImage(String image) {
        this.image=image; return (A) this;
    }

    public Boolean hasImage() {
        return this.image != null;
    }

    public A withNewImage(String arg1) {
        return (A)withImage(new String(arg1));
    }

    public A withNewImage(StringBuilder arg1) {
        return (A)withImage(new String(arg1));
    }

    public A withNewImage(StringBuffer arg1) {
        return (A)withImage(new String(arg1));
    }

    public String getDockerFile() {
        return this.dockerFile;
    }

    public A withDockerFile(String dockerFile) {
        this.dockerFile=dockerFile; return (A) this;
    }

    public Boolean hasDockerFile() {
        return this.dockerFile != null;
    }

    public A withNewDockerFile(String arg1) {
        return (A)withDockerFile(new String(arg1));
    }

    public A withNewDockerFile(StringBuilder arg1) {
        return (A)withDockerFile(new String(arg1));
    }

    public A withNewDockerFile(StringBuffer arg1) {
        return (A)withDockerFile(new String(arg1));
    }

    public Boolean getAutoBuildEnabled() {
        return this.autoBuildEnabled;
    }

    public A withAutoBuildEnabled(Boolean autoBuildEnabled) {
        this.autoBuildEnabled=autoBuildEnabled; return (A) this;
    }

    public Boolean hasAutoBuildEnabled() {
        return this.autoBuildEnabled != null;
    }

    public A withNewAutoBuildEnabled(String arg1) {
        return (A)withAutoBuildEnabled(new Boolean(arg1));
    }

    public A withNewAutoBuildEnabled(boolean arg1) {
        return (A)withAutoBuildEnabled(new Boolean(arg1));
    }

    public Boolean getAutoPushEnabled() {
        return this.autoPushEnabled;
    }

    public A withAutoPushEnabled(Boolean autoPushEnabled) {
        this.autoPushEnabled=autoPushEnabled; return (A) this;
    }

    public Boolean hasAutoPushEnabled() {
        return this.autoPushEnabled != null;
    }

    public A withNewAutoPushEnabled(String arg1) {
        return (A)withAutoPushEnabled(new Boolean(arg1));
    }

    public A withNewAutoPushEnabled(boolean arg1) {
        return (A)withAutoPushEnabled(new Boolean(arg1));
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        ImageConfigurationFluentImpl that = (ImageConfigurationFluentImpl) o;
        if (registry != null ? !registry.equals(that.registry) :that.registry != null) return false;
        if (group != null ? !group.equals(that.group) :that.group != null) return false;
        if (name != null ? !name.equals(that.name) :that.name != null) return false;
        if (version != null ? !version.equals(that.version) :that.version != null) return false;
        if (image != null ? !image.equals(that.image) :that.image != null) return false;
        if (dockerFile != null ? !dockerFile.equals(that.dockerFile) :that.dockerFile != null) return false;
        if (autoBuildEnabled != null ? !autoBuildEnabled.equals(that.autoBuildEnabled) :that.autoBuildEnabled != null) return false;
        if (autoPushEnabled != null ? !autoPushEnabled.equals(that.autoPushEnabled) :that.autoPushEnabled != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(registry,  group,  name,  version,  image,  dockerFile,  autoBuildEnabled,  autoPushEnabled,  super.hashCode());
    }

}
