package io.dekorate.kubernetes.config;

import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class Mount {

    private String name;
    private String path;
    private String subPath;
    private Boolean readOnly;

    public Mount() {
    }

    public Mount(String name,String path,String subPath,Boolean readOnly) {
        this.name = name;
        this.path = path;
        this.subPath = subPath;
        this.readOnly = readOnly;
    }

    public String getName() {
        return this.name;
    }

    public String getPath() {
        return this.path;
    }

    public String getSubPath() {
        return this.subPath;
    }

    public Boolean getReadOnly() {
        return this.readOnly;
    }

    public boolean isReadOnly() {
        return this.readOnly != null &&  this.readOnly;
    }

    public static MountBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.MountBuilder();
    }

    public static MountBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.MountBuilder().withReadOnly(false);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Mount that = (Mount) o;
        if (name != null ? !name.equals(that.name) :that.name != null) return false;
        if (path != null ? !path.equals(that.path) :that.path != null) return false;
        if (subPath != null ? !subPath.equals(that.subPath) :that.subPath != null) return false;
        if (readOnly != null ? !readOnly.equals(that.readOnly) :that.readOnly != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(name,  path,  subPath,  readOnly,  super.hashCode());
    }

}
