package io.dekorate.kubernetes.config;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class PersistentVolumeClaimConfigBuilder extends PersistentVolumeClaimConfigFluentImpl<PersistentVolumeClaimConfigBuilder> implements VisitableBuilder<PersistentVolumeClaimConfig,PersistentVolumeClaimConfigBuilder> {

    PersistentVolumeClaimConfigFluent<?> fluent;
    Boolean validationEnabled;

    public PersistentVolumeClaimConfigBuilder() {
        this(true);
    }

    public PersistentVolumeClaimConfigBuilder(Boolean validationEnabled) {
        this(new PersistentVolumeClaimConfig(), validationEnabled);
    }

    public PersistentVolumeClaimConfigBuilder(PersistentVolumeClaimConfigFluent<?> fluent) {
        this(fluent, true);
    }

    public PersistentVolumeClaimConfigBuilder(PersistentVolumeClaimConfigFluent<?> fluent,Boolean validationEnabled) {
        this(fluent, new PersistentVolumeClaimConfig(), validationEnabled);
    }

    public PersistentVolumeClaimConfigBuilder(PersistentVolumeClaimConfigFluent<?> fluent,PersistentVolumeClaimConfig instance) {
        this(fluent, instance, true);
    }

    public PersistentVolumeClaimConfigBuilder(PersistentVolumeClaimConfigFluent<?> fluent,PersistentVolumeClaimConfig instance,Boolean validationEnabled) {
        this.fluent = fluent; 
        fluent.withProject(instance.getProject()); 
        fluent.withAttributes(instance.getAttributes()); 
        fluent.withPartOf(instance.getPartOf()); 
        fluent.withName(instance.getName()); 
        fluent.withVersion(instance.getVersion()); 
        fluent.withSize(instance.getSize()); 
        fluent.withUnit(instance.getUnit()); 
        fluent.withStorageClass(instance.getStorageClass()); 
        fluent.withAccessMode(instance.getAccessMode()); 
        fluent.withMatchLabels(instance.getMatchLabels()); 
        this.validationEnabled = validationEnabled; 
    }

    public PersistentVolumeClaimConfigBuilder(PersistentVolumeClaimConfig instance) {
        this(instance,true);
    }

    public PersistentVolumeClaimConfigBuilder(PersistentVolumeClaimConfig instance,Boolean validationEnabled) {
        this.fluent = this; 
        this.withProject(instance.getProject()); 
        this.withAttributes(instance.getAttributes()); 
        this.withPartOf(instance.getPartOf()); 
        this.withName(instance.getName()); 
        this.withVersion(instance.getVersion()); 
        this.withSize(instance.getSize()); 
        this.withUnit(instance.getUnit()); 
        this.withStorageClass(instance.getStorageClass()); 
        this.withAccessMode(instance.getAccessMode()); 
        this.withMatchLabels(instance.getMatchLabels()); 
        this.validationEnabled = validationEnabled; 
    }

    public EditablePersistentVolumeClaimConfig build() {
        EditablePersistentVolumeClaimConfig buildable = new EditablePersistentVolumeClaimConfig(fluent.getProject(),fluent.getAttributes(),fluent.getPartOf(),fluent.getName(),fluent.getVersion(),fluent.getSize(),fluent.getUnit(),fluent.getStorageClass(),fluent.getAccessMode(),fluent.getMatchLabels());
        return buildable;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        PersistentVolumeClaimConfigBuilder that = (PersistentVolumeClaimConfigBuilder) o;
        if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;
        
        if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
    }

}
