package io.dekorate.kubernetes.config;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import io.dekorate.project.Project;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Object;
import io.dekorate.kubernetes.annotation.AccessMode;
import java.lang.Boolean;
import java.util.Map;

public interface PersistentVolumeClaimConfigFluent<A extends PersistentVolumeClaimConfigFluent<A>> extends ApplicationConfigurationFluent<A> {


    public int getSize();
    public A withSize(int size);
    public Boolean hasSize();
    public String getUnit();
    public A withUnit(String unit);
    public Boolean hasUnit();
    public A withNewUnit(String arg1);
    public A withNewUnit(StringBuilder arg1);
    public A withNewUnit(StringBuffer arg1);
    public String getStorageClass();
    public A withStorageClass(String storageClass);
    public Boolean hasStorageClass();
    public A withNewStorageClass(String arg1);
    public A withNewStorageClass(StringBuilder arg1);
    public A withNewStorageClass(StringBuffer arg1);
    public AccessMode getAccessMode();
    public A withAccessMode(AccessMode accessMode);
    public Boolean hasAccessMode();
    public A withMatchLabels(io.dekorate.kubernetes.config.Label... matchLabels);
    
/**
 * This method has been deprecated, please use method buildMatchLabels instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Label[] getMatchLabels();
    public io.dekorate.kubernetes.config.Label[] buildMatchLabels();
    public io.dekorate.kubernetes.config.Label buildMatchLabel(int index);
    public io.dekorate.kubernetes.config.Label buildFirstMatchLabel();
    public io.dekorate.kubernetes.config.Label buildLastMatchLabel();
    public io.dekorate.kubernetes.config.Label buildMatchingMatchLabel(Predicate<LabelBuilder> predicate);
    public Boolean hasMatchingMatchLabel(Predicate<LabelBuilder> predicate);
    public A addToMatchLabels(int index,io.dekorate.kubernetes.config.Label item);
    public A setToMatchLabels(int index,io.dekorate.kubernetes.config.Label item);
    public A addToMatchLabels(io.dekorate.kubernetes.config.Label... items);
    public A addAllToMatchLabels(Collection<io.dekorate.kubernetes.config.Label> items);
    public A removeFromMatchLabels(io.dekorate.kubernetes.config.Label... items);
    public A removeAllFromMatchLabels(Collection<io.dekorate.kubernetes.config.Label> items);
    public A removeMatchingFromMatchLabels(Predicate<LabelBuilder> predicate);
    public Boolean hasMatchLabels();
    public A addNewMatchLabel(String key,String value,String[] kinds);
    public PersistentVolumeClaimConfigFluent.MatchLabelsNested<A> addNewMatchLabel();
    public PersistentVolumeClaimConfigFluent.MatchLabelsNested<A> addNewMatchLabelLike(io.dekorate.kubernetes.config.Label item);
    public PersistentVolumeClaimConfigFluent.MatchLabelsNested<A> setNewMatchLabelLike(int index,io.dekorate.kubernetes.config.Label item);
    public PersistentVolumeClaimConfigFluent.MatchLabelsNested<A> editMatchLabel(int index);
    public PersistentVolumeClaimConfigFluent.MatchLabelsNested<A> editFirstMatchLabel();
    public PersistentVolumeClaimConfigFluent.MatchLabelsNested<A> editLastMatchLabel();
    public PersistentVolumeClaimConfigFluent.MatchLabelsNested<A> editMatchingMatchLabel(Predicate<LabelBuilder> predicate);
    public interface MatchLabelsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,LabelFluent<PersistentVolumeClaimConfigFluent.MatchLabelsNested<N>> {

            public N and();
            public N endMatchLabel();    }


}
