package io.dekorate.kubernetes.config;

import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class PersistentVolumeClaimVolume {

    private String volumeName;
    private String claimName;
    private Boolean readOnly;

    public PersistentVolumeClaimVolume() {
    }

    public PersistentVolumeClaimVolume(String volumeName,String claimName,Boolean readOnly) {
        this.volumeName = volumeName;
        this.claimName = claimName;
        this.readOnly = readOnly;
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public String getClaimName() {
        return this.claimName;
    }

    public Boolean getReadOnly() {
        return this.readOnly;
    }

    public boolean isReadOnly() {
        return this.readOnly != null &&  this.readOnly;
    }

    public static PersistentVolumeClaimVolumeBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder();
    }

    public static PersistentVolumeClaimVolumeBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder().withReadOnly(false);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        PersistentVolumeClaimVolume that = (PersistentVolumeClaimVolume) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (claimName != null ? !claimName.equals(that.claimName) :that.claimName != null) return false;
        if (readOnly != null ? !readOnly.equals(that.readOnly) :that.readOnly != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  claimName,  readOnly,  super.hashCode());
    }

}
