package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class PersistentVolumeClaimVolumeFluentImpl<A extends PersistentVolumeClaimVolumeFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements PersistentVolumeClaimVolumeFluent<A> {

    private String volumeName;
    private String claimName;
    private Boolean readOnly;

    public PersistentVolumeClaimVolumeFluentImpl() {
    }

    public PersistentVolumeClaimVolumeFluentImpl(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume instance) {
        this.withVolumeName(instance.getVolumeName()); 
        this.withClaimName(instance.getClaimName()); 
        this.withReadOnly(instance.getReadOnly()); 
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public A withVolumeName(String volumeName) {
        this.volumeName=volumeName; return (A) this;
    }

    public Boolean hasVolumeName() {
        return this.volumeName != null;
    }

    public A withNewVolumeName(String arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuilder arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuffer arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public String getClaimName() {
        return this.claimName;
    }

    public A withClaimName(String claimName) {
        this.claimName=claimName; return (A) this;
    }

    public Boolean hasClaimName() {
        return this.claimName != null;
    }

    public A withNewClaimName(String arg1) {
        return (A)withClaimName(new String(arg1));
    }

    public A withNewClaimName(StringBuilder arg1) {
        return (A)withClaimName(new String(arg1));
    }

    public A withNewClaimName(StringBuffer arg1) {
        return (A)withClaimName(new String(arg1));
    }

    public Boolean getReadOnly() {
        return this.readOnly;
    }

    public A withReadOnly(Boolean readOnly) {
        this.readOnly=readOnly; return (A) this;
    }

    public Boolean hasReadOnly() {
        return this.readOnly != null;
    }

    public A withNewReadOnly(String arg1) {
        return (A)withReadOnly(new Boolean(arg1));
    }

    public A withNewReadOnly(boolean arg1) {
        return (A)withReadOnly(new Boolean(arg1));
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        PersistentVolumeClaimVolumeFluentImpl that = (PersistentVolumeClaimVolumeFluentImpl) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (claimName != null ? !claimName.equals(that.claimName) :that.claimName != null) return false;
        if (readOnly != null ? !readOnly.equals(that.readOnly) :that.readOnly != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  claimName,  readOnly,  super.hashCode());
    }

}
