package io.dekorate.kubernetes.config;

import java.lang.Integer;
import java.lang.Object;
import java.lang.String;
import io.dekorate.kubernetes.annotation.Protocol;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class Port {

    private String name;
    private Integer containerPort;
    private Integer hostPort;
    private String path;
    private Protocol protocol;

    public Port() {
    }

    public Port(String name,Integer containerPort,Integer hostPort,String path,Protocol protocol) {
        this.name = name;
        this.containerPort = containerPort;
        this.hostPort = hostPort;
        this.path = path;
        this.protocol = protocol;
    }

    public String getName() {
        return this.name;
    }

    public Integer getContainerPort() {
        return this.containerPort;
    }

    public Integer getHostPort() {
        return this.hostPort;
    }

    public String getPath() {
        return this.path;
    }

    public Protocol getProtocol() {
        return this.protocol;
    }

    public static PortBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.PortBuilder();
    }

    public static PortBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.PortBuilder().withHostPort(0).withPath("/").withProtocol(io.dekorate.kubernetes.annotation.Protocol.TCP);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Port that = (Port) o;
        if (name != null ? !name.equals(that.name) :that.name != null) return false;
        if (containerPort != null ? !containerPort.equals(that.containerPort) :that.containerPort != null) return false;
        if (hostPort != null ? !hostPort.equals(that.hostPort) :that.hostPort != null) return false;
        if (path != null ? !path.equals(that.path) :that.path != null) return false;
        if (protocol != null ? !protocol.equals(that.protocol) :that.protocol != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(name,  containerPort,  hostPort,  path,  protocol,  super.hashCode());
    }

}
