package io.dekorate.kubernetes.config;

import java.lang.Integer;
import java.lang.Object;
import java.lang.String;

public class Probe {

    private String httpActionPath;
    private String execAction;
    private String tcpSocketAction;
    private Integer initialDelaySeconds;
    private Integer periodSeconds;
    private Integer timeoutSeconds;
    private Integer successThreshold;
    private Integer failureThreshold;

    public Probe() {
    }

    public Probe(String httpActionPath,String execAction,String tcpSocketAction,Integer initialDelaySeconds,Integer periodSeconds,Integer timeoutSeconds,Integer successThreshold,Integer failureThreshold) {
        this.httpActionPath = httpActionPath;
        this.execAction = execAction;
        this.tcpSocketAction = tcpSocketAction;
        this.initialDelaySeconds = initialDelaySeconds;
        this.periodSeconds = periodSeconds;
        this.timeoutSeconds = timeoutSeconds;
        this.successThreshold = successThreshold;
        this.failureThreshold = failureThreshold;
    }

    public String getHttpActionPath() {
        return this.httpActionPath;
    }

    public String getExecAction() {
        return this.execAction;
    }

    public String getTcpSocketAction() {
        return this.tcpSocketAction;
    }

    public Integer getInitialDelaySeconds() {
        return this.initialDelaySeconds;
    }

    public Integer getPeriodSeconds() {
        return this.periodSeconds;
    }

    public Integer getTimeoutSeconds() {
        return this.timeoutSeconds;
    }

    public Integer getSuccessThreshold() {
        return this.successThreshold;
    }

    public Integer getFailureThreshold() {
        return this.failureThreshold;
    }

    public static ProbeBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.ProbeBuilder();
    }

    public static ProbeBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.ProbeBuilder().withInitialDelaySeconds(0).withPeriodSeconds(30).withTimeoutSeconds(10).withSuccessThreshold(1).withFailureThreshold(3);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Probe that = (Probe) o;
        if (httpActionPath != null ? !httpActionPath.equals(that.httpActionPath) :that.httpActionPath != null) return false;
        if (execAction != null ? !execAction.equals(that.execAction) :that.execAction != null) return false;
        if (tcpSocketAction != null ? !tcpSocketAction.equals(that.tcpSocketAction) :that.tcpSocketAction != null) return false;
        if (initialDelaySeconds != null ? !initialDelaySeconds.equals(that.initialDelaySeconds) :that.initialDelaySeconds != null) return false;
        if (periodSeconds != null ? !periodSeconds.equals(that.periodSeconds) :that.periodSeconds != null) return false;
        if (timeoutSeconds != null ? !timeoutSeconds.equals(that.timeoutSeconds) :that.timeoutSeconds != null) return false;
        if (successThreshold != null ? !successThreshold.equals(that.successThreshold) :that.successThreshold != null) return false;
        if (failureThreshold != null ? !failureThreshold.equals(that.failureThreshold) :that.failureThreshold != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(httpActionPath,  execAction,  tcpSocketAction,  initialDelaySeconds,  periodSeconds,  timeoutSeconds,  successThreshold,  failureThreshold,  super.hashCode());
    }

}
