package io.dekorate.kubernetes.config;

import java.lang.Integer;
import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class ProbeFluentImpl<A extends ProbeFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements ProbeFluent<A> {

    private String httpActionPath;
    private String execAction;
    private String tcpSocketAction;
    private Integer initialDelaySeconds;
    private Integer periodSeconds;
    private Integer timeoutSeconds;
    private Integer successThreshold;
    private Integer failureThreshold;

    public ProbeFluentImpl() {
    }

    public ProbeFluentImpl(io.dekorate.kubernetes.config.Probe instance) {
        this.withHttpActionPath(instance.getHttpActionPath()); 
        this.withExecAction(instance.getExecAction()); 
        this.withTcpSocketAction(instance.getTcpSocketAction()); 
        this.withInitialDelaySeconds(instance.getInitialDelaySeconds()); 
        this.withPeriodSeconds(instance.getPeriodSeconds()); 
        this.withTimeoutSeconds(instance.getTimeoutSeconds()); 
        this.withSuccessThreshold(instance.getSuccessThreshold()); 
        this.withFailureThreshold(instance.getFailureThreshold()); 
    }

    public String getHttpActionPath() {
        return this.httpActionPath;
    }

    public A withHttpActionPath(String httpActionPath) {
        this.httpActionPath=httpActionPath; return (A) this;
    }

    public Boolean hasHttpActionPath() {
        return this.httpActionPath != null;
    }

    public A withNewHttpActionPath(String arg1) {
        return (A)withHttpActionPath(new String(arg1));
    }

    public A withNewHttpActionPath(StringBuilder arg1) {
        return (A)withHttpActionPath(new String(arg1));
    }

    public A withNewHttpActionPath(StringBuffer arg1) {
        return (A)withHttpActionPath(new String(arg1));
    }

    public String getExecAction() {
        return this.execAction;
    }

    public A withExecAction(String execAction) {
        this.execAction=execAction; return (A) this;
    }

    public Boolean hasExecAction() {
        return this.execAction != null;
    }

    public A withNewExecAction(String arg1) {
        return (A)withExecAction(new String(arg1));
    }

    public A withNewExecAction(StringBuilder arg1) {
        return (A)withExecAction(new String(arg1));
    }

    public A withNewExecAction(StringBuffer arg1) {
        return (A)withExecAction(new String(arg1));
    }

    public String getTcpSocketAction() {
        return this.tcpSocketAction;
    }

    public A withTcpSocketAction(String tcpSocketAction) {
        this.tcpSocketAction=tcpSocketAction; return (A) this;
    }

    public Boolean hasTcpSocketAction() {
        return this.tcpSocketAction != null;
    }

    public A withNewTcpSocketAction(String arg1) {
        return (A)withTcpSocketAction(new String(arg1));
    }

    public A withNewTcpSocketAction(StringBuilder arg1) {
        return (A)withTcpSocketAction(new String(arg1));
    }

    public A withNewTcpSocketAction(StringBuffer arg1) {
        return (A)withTcpSocketAction(new String(arg1));
    }

    public Integer getInitialDelaySeconds() {
        return this.initialDelaySeconds;
    }

    public A withInitialDelaySeconds(Integer initialDelaySeconds) {
        this.initialDelaySeconds=initialDelaySeconds; return (A) this;
    }

    public Boolean hasInitialDelaySeconds() {
        return this.initialDelaySeconds != null;
    }

    public Integer getPeriodSeconds() {
        return this.periodSeconds;
    }

    public A withPeriodSeconds(Integer periodSeconds) {
        this.periodSeconds=periodSeconds; return (A) this;
    }

    public Boolean hasPeriodSeconds() {
        return this.periodSeconds != null;
    }

    public Integer getTimeoutSeconds() {
        return this.timeoutSeconds;
    }

    public A withTimeoutSeconds(Integer timeoutSeconds) {
        this.timeoutSeconds=timeoutSeconds; return (A) this;
    }

    public Boolean hasTimeoutSeconds() {
        return this.timeoutSeconds != null;
    }

    public Integer getSuccessThreshold() {
        return this.successThreshold;
    }

    public A withSuccessThreshold(Integer successThreshold) {
        this.successThreshold=successThreshold; return (A) this;
    }

    public Boolean hasSuccessThreshold() {
        return this.successThreshold != null;
    }

    public Integer getFailureThreshold() {
        return this.failureThreshold;
    }

    public A withFailureThreshold(Integer failureThreshold) {
        this.failureThreshold=failureThreshold; return (A) this;
    }

    public Boolean hasFailureThreshold() {
        return this.failureThreshold != null;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ProbeFluentImpl that = (ProbeFluentImpl) o;
        if (httpActionPath != null ? !httpActionPath.equals(that.httpActionPath) :that.httpActionPath != null) return false;
        if (execAction != null ? !execAction.equals(that.execAction) :that.execAction != null) return false;
        if (tcpSocketAction != null ? !tcpSocketAction.equals(that.tcpSocketAction) :that.tcpSocketAction != null) return false;
        if (initialDelaySeconds != null ? !initialDelaySeconds.equals(that.initialDelaySeconds) :that.initialDelaySeconds != null) return false;
        if (periodSeconds != null ? !periodSeconds.equals(that.periodSeconds) :that.periodSeconds != null) return false;
        if (timeoutSeconds != null ? !timeoutSeconds.equals(that.timeoutSeconds) :that.timeoutSeconds != null) return false;
        if (successThreshold != null ? !successThreshold.equals(that.successThreshold) :that.successThreshold != null) return false;
        if (failureThreshold != null ? !failureThreshold.equals(that.failureThreshold) :that.failureThreshold != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(httpActionPath,  execAction,  tcpSocketAction,  initialDelaySeconds,  periodSeconds,  timeoutSeconds,  successThreshold,  failureThreshold,  super.hashCode());
    }

}
