package io.dekorate.kubernetes.config;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ResourceRequirementsBuilder extends ResourceRequirementsFluentImpl<ResourceRequirementsBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.ResourceRequirements,ResourceRequirementsBuilder> {

    ResourceRequirementsFluent<?> fluent;
    Boolean validationEnabled;

    public ResourceRequirementsBuilder() {
        this(true);
    }

    public ResourceRequirementsBuilder(Boolean validationEnabled) {
        this(new ResourceRequirements(), validationEnabled);
    }

    public ResourceRequirementsBuilder(ResourceRequirementsFluent<?> fluent) {
        this(fluent, true);
    }

    public ResourceRequirementsBuilder(ResourceRequirementsFluent<?> fluent,Boolean validationEnabled) {
        this(fluent, new ResourceRequirements(), validationEnabled);
    }

    public ResourceRequirementsBuilder(ResourceRequirementsFluent<?> fluent,io.dekorate.kubernetes.config.ResourceRequirements instance) {
        this(fluent, instance, true);
    }

    public ResourceRequirementsBuilder(ResourceRequirementsFluent<?> fluent,io.dekorate.kubernetes.config.ResourceRequirements instance,Boolean validationEnabled) {
        this.fluent = fluent; 
        fluent.withMemory(instance.getMemory()); 
        fluent.withCpu(instance.getCpu()); 
        this.validationEnabled = validationEnabled; 
    }

    public ResourceRequirementsBuilder(io.dekorate.kubernetes.config.ResourceRequirements instance) {
        this(instance,true);
    }

    public ResourceRequirementsBuilder(io.dekorate.kubernetes.config.ResourceRequirements instance,Boolean validationEnabled) {
        this.fluent = this; 
        this.withMemory(instance.getMemory()); 
        this.withCpu(instance.getCpu()); 
        this.validationEnabled = validationEnabled; 
    }

    public io.dekorate.kubernetes.config.ResourceRequirements build() {
        ResourceRequirements buildable = new ResourceRequirements(fluent.getMemory(),fluent.getCpu());
        return buildable;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        ResourceRequirementsBuilder that = (ResourceRequirementsBuilder) o;
        if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;
        
        if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
    }

}
