package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class ResourceRequirementsFluentImpl<A extends ResourceRequirementsFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements ResourceRequirementsFluent<A> {

    private String memory;
    private String cpu;

    public ResourceRequirementsFluentImpl() {
    }

    public ResourceRequirementsFluentImpl(io.dekorate.kubernetes.config.ResourceRequirements instance) {
        this.withMemory(instance.getMemory()); 
        this.withCpu(instance.getCpu()); 
    }

    public String getMemory() {
        return this.memory;
    }

    public A withMemory(String memory) {
        this.memory=memory; return (A) this;
    }

    public Boolean hasMemory() {
        return this.memory != null;
    }

    public A withNewMemory(String arg1) {
        return (A)withMemory(new String(arg1));
    }

    public A withNewMemory(StringBuilder arg1) {
        return (A)withMemory(new String(arg1));
    }

    public A withNewMemory(StringBuffer arg1) {
        return (A)withMemory(new String(arg1));
    }

    public String getCpu() {
        return this.cpu;
    }

    public A withCpu(String cpu) {
        this.cpu=cpu; return (A) this;
    }

    public Boolean hasCpu() {
        return this.cpu != null;
    }

    public A withNewCpu(String arg1) {
        return (A)withCpu(new String(arg1));
    }

    public A withNewCpu(StringBuilder arg1) {
        return (A)withCpu(new String(arg1));
    }

    public A withNewCpu(StringBuffer arg1) {
        return (A)withCpu(new String(arg1));
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ResourceRequirementsFluentImpl that = (ResourceRequirementsFluentImpl) o;
        if (memory != null ? !memory.equals(that.memory) :that.memory != null) return false;
        if (cpu != null ? !cpu.equals(that.cpu) :that.cpu != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(memory,  cpu,  super.hashCode());
    }

}
