package io.dekorate.kubernetes.config;

import java.lang.Integer;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.fabric8.kubernetes.api.builder") public class SecretVolume {

    private String volumeName;
    private String secretName;
    private Integer defaultMode;
    private Boolean optional;

    public SecretVolume() {
    }

    public SecretVolume(String volumeName,String secretName,Integer defaultMode,Boolean optional) {
        this.volumeName = volumeName;
        this.secretName = secretName;
        this.defaultMode = defaultMode;
        this.optional = optional;
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public String getSecretName() {
        return this.secretName;
    }

    public Integer getDefaultMode() {
        return this.defaultMode;
    }

    public Boolean getOptional() {
        return this.optional;
    }

    public boolean isOptional() {
        return this.optional != null &&  this.optional;
    }

    public static SecretVolumeBuilder newBuilder() {
        return new io.dekorate.kubernetes.config.SecretVolumeBuilder();
    }

    public static SecretVolumeBuilder newBuilderFromDefaults() {
        return new io.dekorate.kubernetes.config.SecretVolumeBuilder().withDefaultMode(384).withOptional(false);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        SecretVolume that = (SecretVolume) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (secretName != null ? !secretName.equals(that.secretName) :that.secretName != null) return false;
        if (defaultMode != null ? !defaultMode.equals(that.defaultMode) :that.defaultMode != null) return false;
        if (optional != null ? !optional.equals(that.optional) :that.optional != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  secretName,  defaultMode,  optional,  super.hashCode());
    }

}
