package io.dekorate.kubernetes.config;

import java.lang.Integer;
import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class SecretVolumeFluentImpl<A extends SecretVolumeFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements SecretVolumeFluent<A> {

    private String volumeName;
    private String secretName;
    private Integer defaultMode;
    private Boolean optional;

    public SecretVolumeFluentImpl() {
    }

    public SecretVolumeFluentImpl(io.dekorate.kubernetes.config.SecretVolume instance) {
        this.withVolumeName(instance.getVolumeName()); 
        this.withSecretName(instance.getSecretName()); 
        this.withDefaultMode(instance.getDefaultMode()); 
        this.withOptional(instance.getOptional()); 
    }

    public String getVolumeName() {
        return this.volumeName;
    }

    public A withVolumeName(String volumeName) {
        this.volumeName=volumeName; return (A) this;
    }

    public Boolean hasVolumeName() {
        return this.volumeName != null;
    }

    public A withNewVolumeName(String arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuilder arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public A withNewVolumeName(StringBuffer arg1) {
        return (A)withVolumeName(new String(arg1));
    }

    public String getSecretName() {
        return this.secretName;
    }

    public A withSecretName(String secretName) {
        this.secretName=secretName; return (A) this;
    }

    public Boolean hasSecretName() {
        return this.secretName != null;
    }

    public A withNewSecretName(String arg1) {
        return (A)withSecretName(new String(arg1));
    }

    public A withNewSecretName(StringBuilder arg1) {
        return (A)withSecretName(new String(arg1));
    }

    public A withNewSecretName(StringBuffer arg1) {
        return (A)withSecretName(new String(arg1));
    }

    public Integer getDefaultMode() {
        return this.defaultMode;
    }

    public A withDefaultMode(Integer defaultMode) {
        this.defaultMode=defaultMode; return (A) this;
    }

    public Boolean hasDefaultMode() {
        return this.defaultMode != null;
    }

    public Boolean getOptional() {
        return this.optional;
    }

    public A withOptional(Boolean optional) {
        this.optional=optional; return (A) this;
    }

    public Boolean hasOptional() {
        return this.optional != null;
    }

    public A withNewOptional(String arg1) {
        return (A)withOptional(new Boolean(arg1));
    }

    public A withNewOptional(boolean arg1) {
        return (A)withOptional(new Boolean(arg1));
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        SecretVolumeFluentImpl that = (SecretVolumeFluentImpl) o;
        if (volumeName != null ? !volumeName.equals(that.volumeName) :that.volumeName != null) return false;
        if (secretName != null ? !secretName.equals(that.secretName) :that.secretName != null) return false;
        if (defaultMode != null ? !defaultMode.equals(that.defaultMode) :that.defaultMode != null) return false;
        if (optional != null ? !optional.equals(that.optional) :that.optional != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(volumeName,  secretName,  defaultMode,  optional,  super.hashCode());
    }

}
