package io.dekorate.project;

import java.nio.file.Path;
import io.fabric8.kubernetes.api.builder.Editable;
import java.lang.String;

public class EditableBuildInfo extends BuildInfo implements io.fabric8.kubernetes.api.builder.Editable<BuildInfoBuilder> {


    public EditableBuildInfo() {
        super();
    }

    
/**
 * Constructor
 * @param name The project name (e.g. maven artifactId).
 * @param version The project version (e.g. maven version).
 * @param packaging The project packaging (e.g. jar, war).
 * @param buildTool The project build tool (e.g. maven, gralde, sbt)
 * @param buildToolVersion The build tool version
 * @param outputFile The output file (the path to the actual jar, war etc).
 * @param classOutputDir The resource output directory (e.g. target/classes, build/classes/main/java etc).
 * @param resourceDir The directory from which application resources should be read. (e.g. target/classes for maven,
 * src/main/resources from gralde and so on).
 */
public EditableBuildInfo(String name,String version,String packaging,String buildTool,String buildToolVersion,Path outputFile,Path classOutputDir,Path resourceDir) {
        super(name, version, packaging, buildTool, buildToolVersion, outputFile, classOutputDir, resourceDir);
    }

    public BuildInfoBuilder edit() {
        return new BuildInfoBuilder(this);
    }

}
