package io.dekorate.project;

import java.nio.file.Path;
import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;
import java.util.LinkedHashMap;

public interface ScmInfoFluent<A extends ScmInfoFluent<A>> extends Fluent<A> {


    public Path getRoot();
    public A withRoot(Path root);
    public Boolean hasRoot();
    public String getBranch();
    public A withBranch(String branch);
    public Boolean hasBranch();
    public A withNewBranch(String arg1);
    public A withNewBranch(StringBuilder arg1);
    public A withNewBranch(StringBuffer arg1);
    public String getCommit();
    public A withCommit(String commit);
    public Boolean hasCommit();
    public A withNewCommit(String arg1);
    public A withNewCommit(StringBuilder arg1);
    public A withNewCommit(StringBuffer arg1);
    public A addToRemote(String key,String value);
    public A addToRemote(Map<String,String> map);
    public A removeFromRemote(String key);
    public A removeFromRemote(Map<String,String> map);
    public Map<String,String> getRemote();
    public <K extends Object,V extends Object>A withRemote(Map<String,String> remote);
    public Boolean hasRemote();
}
