package io.dekorate.project;

import java.nio.file.Path;
import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;
import java.util.Map;
import java.util.LinkedHashMap;

public class ScmInfoFluentImpl<A extends ScmInfoFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements ScmInfoFluent<A> {

    private Path root;
    private String branch;
    private String commit;
    private Map<String,String> remote;

    public ScmInfoFluentImpl() {
    }

    public ScmInfoFluentImpl(ScmInfo instance) {
        this.withRoot(instance.getRoot()); 
        this.withRemote(instance.getRemote()); 
        this.withBranch(instance.getBranch()); 
        this.withCommit(instance.getCommit()); 
    }

    public Path getRoot() {
        return this.root;
    }

    public A withRoot(Path root) {
        this.root=root; return (A) this;
    }

    public Boolean hasRoot() {
        return this.root != null;
    }

    public String getBranch() {
        return this.branch;
    }

    public A withBranch(String branch) {
        this.branch=branch; return (A) this;
    }

    public Boolean hasBranch() {
        return this.branch != null;
    }

    public A withNewBranch(String arg1) {
        return (A)withBranch(new String(arg1));
    }

    public A withNewBranch(StringBuilder arg1) {
        return (A)withBranch(new String(arg1));
    }

    public A withNewBranch(StringBuffer arg1) {
        return (A)withBranch(new String(arg1));
    }

    public String getCommit() {
        return this.commit;
    }

    public A withCommit(String commit) {
        this.commit=commit; return (A) this;
    }

    public Boolean hasCommit() {
        return this.commit != null;
    }

    public A withNewCommit(String arg1) {
        return (A)withCommit(new String(arg1));
    }

    public A withNewCommit(StringBuilder arg1) {
        return (A)withCommit(new String(arg1));
    }

    public A withNewCommit(StringBuffer arg1) {
        return (A)withCommit(new String(arg1));
    }

    public A addToRemote(String key,String value) {
        if(this.remote == null && key != null && value != null) { this.remote = new LinkedHashMap<String,String>(); }
        if(key != null && value != null) {this.remote.put(key, value);} return (A)this;
    }

    public A addToRemote(Map<String,String> map) {
        if(this.remote == null && map != null) { this.remote = new LinkedHashMap<String,String>(); }
        if(map != null) { this.remote.putAll(map);} return (A)this;
    }

    public A removeFromRemote(String key) {
        if(this.remote == null) { return (A) this; }
        if(key != null && this.remote != null) {this.remote.remove(key);} return (A)this;
    }

    public A removeFromRemote(Map<String,String> map) {
        if(this.remote == null) { return (A) this; }
        if(map != null) { for(Object key : map.keySet()) {if (this.remote != null){this.remote.remove(key);}}} return (A)this;
    }

    public Map<String,String> getRemote() {
        return this.remote;
    }

    public <K extends Object,V extends Object>A withRemote(Map<String,String> remote) {
        if (remote == null) { this.remote =  null;} else {this.remote = new LinkedHashMap<String,String>(remote);} return (A) this;
    }

    public Boolean hasRemote() {
        return this.remote != null;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ScmInfoFluentImpl that = (ScmInfoFluentImpl) o;
        if (root != null ? !root.equals(that.root) :that.root != null) return false;
        if (branch != null ? !branch.equals(that.branch) :that.branch != null) return false;
        if (commit != null ? !commit.equals(that.commit) :that.commit != null) return false;
        if (remote != null ? !remote.equals(that.remote) :that.remote != null) return false;
        return true;
    }

    public int hashCode() {
        return java.util.Objects.hash(root,  branch,  commit,  remote,  super.hashCode());
    }

}
